﻿
var t; //Timer reference
var i; //Random kana selector

var txtCharacter;
var txtRomaji;


//Kana Lists
var hiragana = ["あ",　"え",　"い",　"お",　"う",
				"か", "け", "き", "こ", "く",
				"さ", "せ", "し", "そ", "す",
				"た", "て", "ち", "と", "つ",
				"な", "ね", "に", "の", "ぬ",
				"は", "へ", "ひ", "ほ", "ふ",
				"ま", "め", "み", "も", "む",
				"や", "よ", "ゆ",
				"ら", "れ", "り", "ろ", "る",
				"わ", "を", "ん"];

var katakana = ["ア", "エ", "イ", "オ", "ウ",
				"カ", "ケ", "キ", "コ", "ク",
				"サ", "セ", "シ", "ソ", "ス",
				"タ", "テ", "チ", "ト", "ツ",
				"ナ", "ネ", "ニ", "ノ", "ヌ",
				"ハ", "ヘ", "ヒ", "ホ", "フ",
				"マ", "メ", "ミ", "モ", "ム",
				"ヤ", "ヨ", "ユ",
				"ラ", "レ", "リ", "ロ", "ル",
				"ワ", "ヲ", "ン"];
				
var romaji = [	"a", "e", "i", "o", "u",
				"ka", "ke", "ki", "ko", "ku",
				"sa", "se", "shi", "so", "su",
				"ta", "te", "chi", "to", "tsu",
				"na", "ne", "ni", "no", "nu",
				"ha", "he", "hi", "ho", "fu",
				"ma", "me", "mi", "mo", "mu",
				"ya", "yo", "yu",
				"ra", "re", "ri", "ro", "ru",
				"wa", "wo", "n"];

// Declare delegates
System.Gadget.onDock = dockState;
System.Gadget.onUndock = dockState;
System.Gadget.onSettingsClosed = SettingsClosed;
System.Gadget.onShowSettings = SettingsShow;

//Settings UI
System.Gadget.settingsUI = "Settings.html";

//Functions
function initGadget() {
	loadSettings();
	
	txtCharacter = imgBackground.addTextObject("I", "Verdana", 70, "Black", 64, 20);
	txtCharacter.addGlow("white", 10, 50);
	txtCharacter.align = 1; //center align
	
	txtRomaji = imgBackground.addTextObject("init", "Verdana", 20, "Black", 64, 85);
	txtRomaji.addGlow("white", 10, 50);
	txtRomaji.align = 1; //center align
	txtRomaji.opacity = 0;
	
	//start kana updating
	updateKana();
}

function rand(n) {
  return (  Math.floor( Math.random() * n ) );
}

function updateKana() {
	i = rand(46);
	
	if(System.Gadget.Settings.readString("Hiragana") == "true" && System.Gadget.Settings.readString("Katakana") == "true") {
		if(rand(10) < 5) {
			txtCharacter.value = hiragana[i];
		} else {
			txtCharacter.value = katakana[i];
		}
	} else if(System.Gadget.Settings.readString("Hiragana") == "true") {
		txtCharacter.value = hiragana[i];
		
	} else if(System.Gadget.Settings.readString("Katakana") == "true") {
		txtCharacter.value = katakana[i];
		
	}
	txtRomaji.value = romaji[i];
	t = setTimeout("updateKana()", parseInt(System.Gadget.Settings.read("Interval"))*60000);
}

function dockState() {
	System.Gadget.beginTransition();	
	if (System.Gadget.docked) 
	{
		imgBackground.height = 128;
        imgBackground.width = 128;
		
        txtCharacter.fontsize = 70;
        txtRomaji.opacity = 0;
    }
    else
    {
        imgBackground.height = 128;
        imgBackground.width = 128;
                
        txtCharacter.fontsize = 50;
        txtRomaji.opacity = 100;
    }
	System.Gadget.endTransition(System.Gadget.TransitionType.morph, 0.5);
}

function loadSettings() {
	System.Gadget.Settings.writeString("Hiragana", "true");
	System.Gadget.Settings.writeString("Katakana", "false");
	//System.Gadget.Settings.writeString("Random", "true");
	System.Gadget.Settings.write("Interval", 60);
	System.Gadget.Settings.write("Background", 0);
}

function SettingsShow() {
	clearTimeout(t);
}

function SettingsClosed(event)
{
    // User hit OK on the settings page.
    if (event.closeAction == event.Action.commit)
    {
        if(System.Gadget.Settings.readString("UpdateKana") == "true") {
			updateKana();
		}
		
		var oBackground = document.getElementById("imgBackground");
		
		switch(System.Gadget.Settings.read("Background")) {
			case 0:
				oBackground.src = "url(images/background1blue.png)";
				break;
			case 1:
				oBackground.src = "url(images/background1black.png)";
				break;
			case 2:
				oBackground.src = "url(images/background1red.png)";
				break;
			case 3:
				oBackground.src = "url(images/background1yellow.png)";
				break;
			case 4:
				oBackground.src = "url(images/background2blue.png)";
				break;
			case 5:
				oBackground.src = "url(images/background2black.png)";
				break;
			default:
				oBackground.src = "url(images/background1blue.png)";
				break;
		}

    }
}